import socket

class Netcat:
    """ Python 'netcat like' module """
    def __init__(self, ip, port):
        self.buff = ""
        self.socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.socket.connect((ip, port))

    def read(self, length=1024):
        """ Read 1024 bytes off the socket """
        data = self.socket.recv(length).decode('utf-8').strip()
        return data

    def write(self, data):
        data = data + "\n"
        self.socket.send(data.encode("ascii"))

    def close(self):
        self.socket.close()

# start a new Netcat() instance
nc = Netcat('127.0.0.1', 9994)

# get to the prompt
print(nc.read())

iters = 0
flag = ""
respuesta = ""
while True:
    low = 47
    high = 130
    mid = 0
    while low <= high:
        iters += 1
        mid = (high + low) // 2
        curFlag = flag+chr(mid).strip()
        nc.write(curFlag)
        respuesta = nc.read()
        print(curFlag)
        while not (("Mas " + curFlag in respuesta) or ("Menos " + curFlag in respuesta) or ("Caracter" in respuesta) or ("Premio" in respuesta)):
            respuesta = nc.read()
        if "Caracter" in respuesta:
            flag = flag+chr(mid).strip()
            print(flag)
            break
        elif "Premio" in respuesta:
            flag = flag+chr(mid).strip()
            print("Flag -> " + flag)
            break
        elif "Mas" in respuesta:
            low = mid + 1
        elif "Menos" in respuesta:
            high = mid - 1
    if "Premio" in respuesta:
        break
print(iters)
